drop table linha_compra;
drop table compra;
drop table cliente;
drop table produto;

create table produto(
  id number(15,0) not null,
  nome varchar2(200 char) not null,
  preco_unitario number(15,3) not null
);
alter table produto add constraint pk_produto primary key (id);

/*alter table produto drop constraint pk_produto;
alter table produto add primary key (id);*/

create table cliente(
  id number(15,0) not null,
  nome varchar2(200 char) not null,
  n_cartao_multib varchar2(30 char) not null
);
alter table cliente add constraint pk_cliente primary key (id);
alter table cliente add constraint uk_cliente unique (n_cartao_multib);

create table compra(
  id number(15,0) not null,
  data_compra date not null,
  id_cliente number(15,0) null,
);
alter table compra add constraint pk_compra primary key (id);
alter table compra add constraint fk_compra 
  foreign key (id_cliente) references cliente(id);

create table linha_compra (
  id_compra number(15,0) not null,
  id_produto number(15,0) not null,
  quantidade number(15,3) not null
);
alter table linha_compra add constraint pk_linha_compra
  primary key (id_compra,id_produto);
alter table linha_compra add constraint fk1_linha_compra
  foreign key (id_compra) references compra(id);
alter table linha_compra add constraint fk2_linha_compra
  foreign key (id_produto) references produto(id);
-- alter table linha_compra drop constraint fk2_linha_compra;

insert into produto (id,nome,preco_unitario)
  values (1,'Cereais Chocapic caixa 350g',2.50);
insert into produto (id,nome,preco_unitario)
  values (2,'Leite UHT Magro',0.50);
insert into produto (id,nome,preco_unitario)
  values (3,'Po integral fatiado',1.20);
insert into produto (id,nome,preco_unitario)
  values (4,'Camisola do Benfica',60.00);
insert into produto (id,nome,preco_unitario)
  values (5,'Melo do Ribatejo',1.00); 
/*
insert into produto (id,nome,preco_unitario)
  values (1,'Leite UHT Magro',0.50);
update produto
  set id=2
  where nome='Leite UHT Magro';
*/
select * from produto;
commit;
rollback;

insert into cliente (id,nome,n_cartao_multib)
  values(1,'Antonio Joaquim',123456789);
insert into cliente (id,nome,n_cartao_multib)
  values(2,'Andreia Marques',123456780);

insert into compra (id,id_cliente,data_compra)
  values (1,1,to_date('2013-05-07','yyyy-mm-dd'));
insert into compra (id,id_cliente,data_compra)
  values (2,1,to_date('2013-05-07','yyyy-mm-dd')); 
insert into compra (id,id_cliente,data_compra)
  values (3,2,to_date('2013-05-08','yyyy-mm-dd'));
select id,id_cliente,to_char(data_compra,'yyyy-mm-dd')
from compra;

insert into linha_compra (id_compra,id_produto,quantidade)
  values (1,1,2);
insert into linha_compra (id_compra,id_produto,quantidade)
  values (1,2,6);
insert into linha_compra (id_compra,id_produto,quantidade)
  values (1,3,2);
insert into linha_compra (id_compra,id_produto,quantidade)
  values (2,1,1);
insert into linha_compra (id_compra,id_produto,quantidade)
  values (2,4,1);
insert into linha_compra (id_compra,id_produto,quantidade)
  values (2,5,0.5);
insert into linha_compra (id_compra,id_produto,quantidade)
  values (3,5,1);
select * from linha_compra;

select cliente.nome, 
       cliente.n_cartao_multib, 
       compra.data_compra,
       produto.nome,
       produto.preco_unitario,
       linha_compra.quantidade,
       produto.preco_unitario*linha_compra.quantidade
from cliente
inner join compra on (cliente.id=compra.id_cliente)
inner join linha_compra on (compra.id=linha_compra.id_compra)
inner join produto on (produto.id=linha_compra.id_produto)
where cliente.id=1 and compra.id=1;





